CleanBattlemap = CreateFrame("Frame");
BattlemapScale = 1.0;
BattlemapPinSize = 30;
local width = 0;
local height = 0;
local CleanBattlemapEvents = {}
BattlefieldMap_LoadUI()

function CleanBattleMap_IsBadTile(xOfs)
  local n = math.floor(xOfs / width + 0.5);
  return n == 0 or n == 3;
end

function CleanBattlemap_FixMap()
  for k,v in pairs ({BattlefieldMapFrame.ScrollContainer.Child:GetChildren()}) do
    if(k == 4) then
      for k2, v2 in pairs({v:GetRegions()}) do
        local _, _, _, xOfs, yOfs = v2:GetPoint();
        if(width == 0) then
          width = v2:GetWidth();
          height = v2:GetHeight();
        end
        if(CleanBattleMap_IsBadTile(xOfs)) then
          v2:Hide();
        end
      end
    end
  end
  BattlefieldMapFrame.BorderFrame.CloseButton:Hide()
  BattlefieldMapFrame.BorderFrame.CloseButtonBorder:Hide()
  BattlefieldMapFrame.BorderFrame.TopLeft:Hide()
  BattlefieldMapFrame.BorderFrame.TopRight:Hide()
  BattlefieldMapFrame.BorderFrame.BottomLeft:Hide()
  BattlefieldMapFrame.BorderFrame.BottomRight:Hide()
  BattlefieldMapFrame.BorderFrame.Bottom:Hide()
  BattlefieldMapFrame.BorderFrame.Top:Hide()
  BattlefieldMapFrame.BorderFrame.Left:Hide()
  BattlefieldMapFrame.BorderFrame.Right:Hide()
  BattlefieldMapFrame:SetScale(BattlemapScale);
  if(CleanBattlemap_HasLeatrixMaps()) then
    CleanBattlemap_SetPins();
  end
end

function CleanBattlemapEvents:ZONE_CHANGED_NEW_AREA(...)
  if(C_Map.GetBestMapForUnit("player") == 1460) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:AREA_SPIRIT_HEALER_IN_RANGE(...)
  if(C_Map.GetBestMapForUnit("player") == 1460) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemapEvents:PLAYER_LOGIN(...)
  if(C_Map.GetBestMapForUnit("player") == 1460) then
    CleanBattlemap_FixMap();
  end
end

function CleanBattlemap_HasLeatrixMaps()
  return LeaMapsDB ~= nil;
end

--code from leatrix_maps
function CleanBattlemap_SetPins()
			local BattlefieldMapUnitPin, BattlefieldMapUnitPinSizes
			local partyTexture = "Interface\\AddOns\\Leatrix_Maps\\Leatrix_Maps_Icon.blp"

			-- Set group icon textures
			for pin in BattlefieldMapFrame:EnumeratePinsByTemplate("GroupMembersPinTemplate") do
				BattlefieldMapUnitPin = pin
				BattlefieldMapUnitPinSizes = pin.dataProvider:GetUnitPinSizesTable()
				BattlefieldMapUnitPin:SetPinTexture("raid", partyTexture)
				BattlefieldMapUnitPin:SetPinTexture("party", partyTexture)
				hooksecurefunc(BattlefieldMapUnitPin, "UpdateAppearanceData", function(self)
					self:SetPinTexture("raid", partyTexture)
					self:SetPinTexture("party", partyTexture)
          self:SetPinSize("party", BattlemapPinSize)
          self:SetPinSize("raid", BattlemapPinSize)
				end)
				break
			end

			-- Enable class colors
			BattlefieldMapUnitPin:SetAppearanceField("party", "useClassColor", true)
			BattlefieldMapUnitPin:SetAppearanceField("raid", "useClassColor", true)
			BattlefieldMapUnitPin:SetPinSize("party", BattlemapPinSize)
			BattlefieldMapUnitPin:SetPinSize("raid", BattlemapPinSize)
end

CleanBattlemap:SetScript("OnEvent", function(self, event, ...)
  CleanBattlemapEvents[event](self, ...);
end);
for k, v in pairs(CleanBattlemapEvents) do
  CleanBattlemap:RegisterEvent(k);
end

local function CleanBattlemap_Command(msg, editbox)
  msg = strlower(msg);
  local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
  if(cmd == "scale" or cmd == "pin") then
    local size = tonumber(args);
    if(cmd == "scale") then
      if(size ~= nil) then
        print("Scale set to " .. size);
        BattlemapScale = size;
      else
        print("Scale must be set to a number!");
      end
    else
      if(size ~= nil) then
        print("Pin size set to " .. size);
        BattlemapPinSize = size;
      else
        print("Pin size must be set to a number!");
      end
    end
  else
    print("Command usage: /cbm scale|pin n");
    print("'/cbm scale x' - currently: " .. BattlemapScale);
    print("'/cbm pin n' - currently: " .. BattlemapPinSize);
  end
  if(C_Map.GetBestMapForUnit("player") == 1460) then
    CleanBattlemap_FixMap();
  end
end


SLASH_CLEANBATTLEMAP1, SLASH_CLEANBATTLEMAP2 = '/cleanbattlemap', '/cbm'

SlashCmdList["CLEANBATTLEMAP"] = CleanBattlemap_Command;
